import React from "react";
class Fancybox extends React.Component {
    constructor() {
        this.state = {
            showBox: false,
        }
    }

    showBox(event) {
        event.preventDefault();
        this.setState({
            showBox: true,
        });
    }

    onBoxClick(event) {
        event.preventDefault();
        if (event.target != this.refs.imageInBox) {
            this.setState({
                showBox: false,
            })
        }
    }

    render() {
        let box = '';
        if (this.state.showBox) {
            box = (
                <div onClick={this.onBoxClick.bind(this)} ref="box" class="fancy-box">
                    <span onClick={() => this.setState({showBox: false})} class="close">&times;</span>
                    <img ref="imageInBox" src={this.props.imageUrl}/>
                    <div>{this.props.caption}</div>
                </div>
            );
        }
        return (
            <div>
                <style>
                    .fancy-box {
                        position: fixed; /* Stay in place */
                        z-index: 1; /* Sit on top */
                        padding-top: 100px; /* Location of the box */
                        left: 0;
                        top: 0;
                        width: 100%; /* Full width */
                        height: 100%; /* Full height */
                        overflow: auto; /* Enable scroll if needed */
                        background-color: rgb(0,0,0); /* Fallback color */
                        background-color: rgba(0,0,0,0.9); /* Black w/ opacity */
                    }
                </style>
                <img onClick={this.showBox.bind(this)} src={this.props.imageUrl} className={this.props.imageClassName}/>
            </div>
        );
    }
}

Fancybox.defaultProps = {
    imageUrl: '',
    imageClassName = 'fancybox-img',
    caption: '',
}

export default Fancybox;